function Gibberish() {
	this.inputArray = new Array();
	this.outputArray = new Array();
	this.outputString = new String('');
	this.outputEncoding = new String('none');
	this.outputLength = 1;
}

// Property access methods
Gibberish.prototype.setInputArray = function(inputVariable) {
	this.inputArray = new Array();
	if (inputVariable[0]) {
		for (count = 0; count < inputVariable.length; count++) {
			if (inputVariable == Number.NaN) {
				this.inputArray[count] = inputVariable[count].charCodeAt(0);
			} else {
				this.inputArray[count] = inputVariable[count];
			}
		}
	} else if (inputVariable == Number.NaN) {
		for (count = 0; count < inputVariable.length; count++) {
			this.inputArray[count] = inputVariable[count].charCodeAt(0);
		}
	} else {
		this.inputArray[0] = inputVariable;
	}
	return this.input_array;
}

Gibberish.prototype.setOutputEncoding = function(inputEncoding) {
	switch (inputEncoding.toLowerCase()) {
		case 'none':
		case 'special':
		case 'all':
		case 'hex':
		case 'dec':
		case 'url':
		case 'rawurl':
			this.outputEncoding = inputEncoding.toLowerCase();
			break;
		default:
			this.outputEncoding = 'none';
			break;
	}
	return this.outputEncoding;
}

Gibberish.prototype.setOutputLength = function(inputLength) {
	if (inputLength == Number.NaN) {
		this.outputLength = inputLength.length;
	} else {
		this.outputLength = inputLength;
	}
	return this.outputLength;
}

Gibberish.prototype.getInputArray = function() {
	return this.inputArray;
}

Gibberish.prototype.getOutputArray = function() {
	return this.outputArray;
}

Gibberish.prototype.getInputString = function() {
	inputString = '';
	for (count = 0; count < this.inputArray.length; count++) {
		inputString += this.inputArray[count] + '  ';
	}
	return inputString;
}

Gibberish.prototype.getOutputString = function() {
	return this.outputString;
}

Gibberish.prototype.getOutputEncoding = function() {
	return this.outputEncoding;
}

Gibberish.prototype.getOutputLength = function() {
	return this.outputLength;
}

// Main gibber method
Gibberish.prototype.gibber = function() {
	for (count = 0; count < this.outputLength; count++) {
		this.outputArray[count] = this.inputArray[Math.floor(Math.random() * this.inputArray.length)];
	}
	switch (this.outputEncoding) {
		case 'none':
			this.encodeNone();
			break;
		case 'special':
			this.encodeSpecial();
			break;
		case 'all':
			this.encodeAll();
			break;
		case 'hex':
			this.encodeHex();
			break;
		case 'dec':
			this.encodeDec();
			break;
		case 'url':
			this.encodeUrl();
			break;
		case 'rawurl':
			this.encodeRawurl();
			break;
		default:
			this.encodeNone();
			break;
	}
	return this.outputString;
}

// Methods to set input_array
Gibberish.prototype.gibberAlpha = function() {
	outputArray = new Array();
	for (count = 0x0041; count <= 0x007a; count++) {
		if (((count >= 0x0041) && (count <= 0x005a)) || ((count >= 0x0061) && (count <= 0x007a))) {
			outputArray[outputArray.length] = count;
		}
	}
	this.setInputArray(outputArray);
	return this.gibber();
}

Gibberish.prototype.gibberCaps = function() {
	outputArray = new Array();
	for (count = 0x0041; count <= 0x005a; count++) {
		outputArray[outputArray.length] = count;
	}
	this.setInputArray(outputArray);
	return this.gibber();
}

Gibberish.prototype.gibberNocaps = function() {
	outputArray = new Array();
	for (count = 0x0061; count <= 0x007a; count++) {
		outputArray[outputArray.length] = count;
	}
	this.setInputArray(outputArray);
	return this.gibber();
}

Gibberish.prototype.gibberNum = function() {
	outputArray = new Array();
	for (count = 0x0030; count <= 0x0039; count++) {
		outputArray[outputArray.length] = count;
	}
	this.setInputArray(outputArray);
	return this.gibber();
}

Gibberish.prototype.gibberAlphanum = function() {
	outputArray = new Array();
	for (count = 0x0030; count <= 0x007a; count++) {
		if (((count >= 0x0030) && (count <= 0x0039)) || ((count >= 0x0041) && (count <= 0x005a)) || ((count >= 0x0061) && (count <= 0x007a))) {
			outputArray[outputArray.length] = count;
		}
	}
	this.setInputArray(outputArray);
	return this.gibber();
}

Gibberish.prototype.gibberCapsnum = function() {
	outputArray = new Array();
	for (count = 0x0030; count <= 0x005a; count++) {
		if (((count >= 0x0030) && (count <= 0x0039)) || ((count >= 0x0041) && (count <= 0x005a))) {
			outputArray[outputArray.length] = count;
		}
	}
	this.setInputArray(outputArray);
	return this.gibber();
}

Gibberish.prototype.gibberNocapsnum = function() {
	outputArray = new Array();
	for (count = 0x0030; count <= 0x007a; count++) {
		if (((count >= 0x0030) && (count <= 0x0039)) || ((count >= 0x0061) && (count <= 0x007a))) {
			outputArray[outputArray.length] = count;
		}
	}
	this.setInputArray(outputArray);
	return this.gibber();
}

Gibberish.prototype.gibberMixed = function() {
	outputArray = new Array();
	for (count = 0x0021; count <= 0x007e; count++) {
		outputArray[outputArray.length] = count;
	}
	this.setInputArray(outputArray);
	return this.gibber();
}

Gibberish.prototype.gibberSymbols = function() {
	outputArray = new Array();
	for (count = 0x0021; count <= 0x007e; count++) {
		if (((count >= 0x0021) && (count <= 0x0029)) || (count == 0x0040) || ((count >= 0x005b) && (count <= 0x0060)) || ((count >= 0x007b) && (count <= 0x007e))) {
			outputArray[outputArray.length] = count;
		}
	}
	this.setInputArray(outputArray);
	return this.gibber();
}

// Encoding methods
Gibberish.prototype.encodeSpecial = function() {
	outputString = '';
	for (count = 0; count < this.outputLength; count++) {
		outputString += String.fromCharCode(this.outputArray[count]);
	}
	this.outputString = outputString.encodeSpecialChars();
	return this.outputString;
}

Gibberish.prototype.encodeAll = function() {
	outputString = '';
	for (count = 0; count < this.outputLength; count++) {
		outputString += String.fromCharCode(this.outputArray[count]);
	}
	this.outputString = outputString.encodeEntities();
	return this.outputString;
}

Gibberish.prototype.encodeHex = function() {
	outputString = '';
	for (count = 0; count < this.outputLength; count++) {
		outputString += '&#x' + this.outputArray[count].toString(16) + ';';
	}
	this.outputString = outputString;
	return this.outputString;
}

Gibberish.prototype.encodeDec = function() {
	outputString = '';
	for (count = 0; count < this.outputLength; count++) {
		outputString += '&#' + this.outputArray[count].toString(10) + ';';
	}
	this.outputString = outputString;
	return this.outputString;
}

Gibberish.prototype.encodeUrl = function() {
	outputString = '';
	for (count = 0; count < this.outputLength; count++) {
		outputString += String.fromCharCode(this.outputArray[count]);
	}
	outputString = escapeURI(outputString);
	this.outputString = outputString.replace(/%20/, '+');
	return this.outputString;
}

Gibberish.prototype.encodeRawurl = function() {
	outputString = '';
	for (count = 0; count < this.outputLength; count++) {
		outputString += String.fromCharCode(this.outputArray[count]);
	}
	this.outputString = escapeURI(outputString);
	return this.outputString;
}

Gibberish.prototype.encodeNone = function() {
	outputString = '';
	for (count = 0; count < this.outputLength; count++) {
		outputString += String.fromCharCode(this.outputArray[count]);
	}
	this.outputString = outputString;
	return this.outputString;
}

// Extensions to String class

String.prototype.encodeSpecialChars = function() {
	encodingString = this.substr(0);

	encodingString = encodingString.replace(/&/g, '&amp;');
	encodingString = encodingString.replace(/</g, '&lt;');
	encodingString = encodingString.replace(/>/g, '&gt;');
	encodingString = encodingString.replace(/"/g, '&quot;');
	encodingString = encodingString.replace(/'/g, '&#039;');

	return encodingString;
}
String.prototype.encodeEntities = function() {
	encodingString = this.substr(0);

	encodingString = encodingString.replace(/&/g, '&amp;');
	encodingString = encodingString.replace(/ /g, '&nbsp;');
	encodingString = encodingString.replace(//g, '&iexcl;');
	encodingString = encodingString.replace(//g, '&cent;');
	encodingString = encodingString.replace(//g, '&pound;');
	encodingString = encodingString.replace(//g, '&curren;');
	encodingString = encodingString.replace(//g, '&yen;');
	encodingString = encodingString.replace(//g, '&brvbar;');
	encodingString = encodingString.replace(//g, '&sect;');
	encodingString = encodingString.replace(//g, '&uml;');
	encodingString = encodingString.replace(//g, '&copy;');
	encodingString = encodingString.replace(//g, '&ordf;');
	encodingString = encodingString.replace(//g, '&laquo;');
	encodingString = encodingString.replace(//g, '&not;');
	encodingString = encodingString.replace(//g, '&shy;');
	encodingString = encodingString.replace(//g, '&reg;');
	encodingString = encodingString.replace(//g, '&macr;');
	encodingString = encodingString.replace(//g, '&deg;');
	encodingString = encodingString.replace(//g, '&plusmn;');
	encodingString = encodingString.replace(//g, '&sup2;');
	encodingString = encodingString.replace(//g, '&sup3;');
	encodingString = encodingString.replace(//g, '&acute;');
	encodingString = encodingString.replace(//g, '&micro;');
	encodingString = encodingString.replace(//g, '&para;');
	encodingString = encodingString.replace(//g, '&middot;');
	encodingString = encodingString.replace(//g, '&cedil;');
	encodingString = encodingString.replace(//g, '&sup1;');
	encodingString = encodingString.replace(//g, '&ordm;');
	encodingString = encodingString.replace(//g, '&raquo;');
	encodingString = encodingString.replace(//g, '&frac14;');
	encodingString = encodingString.replace(//g, '&frac12;');
	encodingString = encodingString.replace(//g, '&frac34;');
	encodingString = encodingString.replace(//g, '&iquest;');
	encodingString = encodingString.replace(//g, '&Agrave;');
	encodingString = encodingString.replace(//g, '&Aacute;');
	encodingString = encodingString.replace(//g, '&Acirc;');
	encodingString = encodingString.replace(//g, '&Atilde;');
	encodingString = encodingString.replace(//g, '&Auml;');
	encodingString = encodingString.replace(//g, '&Aring;');
	encodingString = encodingString.replace(//g, '&AElig;');
	encodingString = encodingString.replace(//g, '&Ccedil;');
	encodingString = encodingString.replace(//g, '&Egrave;');
	encodingString = encodingString.replace(//g, '&Eacute;');
	encodingString = encodingString.replace(//g, '&Ecirc;');
	encodingString = encodingString.replace(//g, '&Euml;');
	encodingString = encodingString.replace(//g, '&Igrave;');
	encodingString = encodingString.replace(//g, '&Iacute;');
	encodingString = encodingString.replace(//g, '&Icirc;');
	encodingString = encodingString.replace(//g, '&Iuml;');
	encodingString = encodingString.replace(//g, '&ETH;');
	encodingString = encodingString.replace(//g, '&Ntilde;');
	encodingString = encodingString.replace(//g, '&Ograve;');
	encodingString = encodingString.replace(//g, '&Oacute;');
	encodingString = encodingString.replace(//g, '&Ocirc;');
	encodingString = encodingString.replace(//g, '&Otilde;');
	encodingString = encodingString.replace(//g, '&Ouml;');
	encodingString = encodingString.replace(//g, '&times;');
	encodingString = encodingString.replace(//g, '&Oslash;');
	encodingString = encodingString.replace(//g, '&Ugrave;');
	encodingString = encodingString.replace(//g, '&Uacute;');
	encodingString = encodingString.replace(//g, '&Ucirc;');
	encodingString = encodingString.replace(//g, '&Uuml;');
	encodingString = encodingString.replace(//g, '&Yacute;');
	encodingString = encodingString.replace(//g, '&THORN;');
	encodingString = encodingString.replace(//g, '&szlig;');
	encodingString = encodingString.replace(//g, '&agrave;');
	encodingString = encodingString.replace(//g, '&aacute;');
	encodingString = encodingString.replace(//g, '&acirc;');
	encodingString = encodingString.replace(//g, '&atilde;');
	encodingString = encodingString.replace(//g, '&auml;');
	encodingString = encodingString.replace(//g, '&aring;');
	encodingString = encodingString.replace(//g, '&aelig;');
	encodingString = encodingString.replace(//g, '&ccedil;');
	encodingString = encodingString.replace(//g, '&egrave;');
	encodingString = encodingString.replace(//g, '&eacute;');
	encodingString = encodingString.replace(//g, '&ecirc;');
	encodingString = encodingString.replace(//g, '&euml;');
	encodingString = encodingString.replace(//g, '&igrave;');
	encodingString = encodingString.replace(//g, '&iacute;');
	encodingString = encodingString.replace(//g, '&icirc;');
	encodingString = encodingString.replace(//g, '&iuml;');
	encodingString = encodingString.replace(//g, '&eth;');
	encodingString = encodingString.replace(//g, '&ntilde;');
	encodingString = encodingString.replace(//g, '&ograve;');
	encodingString = encodingString.replace(//g, '&oacute;');
	encodingString = encodingString.replace(//g, '&ocirc;');
	encodingString = encodingString.replace(//g, '&otilde;');
	encodingString = encodingString.replace(//g, '&ouml;');
	encodingString = encodingString.replace(//g, '&divide;');
	encodingString = encodingString.replace(//g, '&oslash;');
	encodingString = encodingString.replace(//g, '&ugrave;');
	encodingString = encodingString.replace(//g, '&uacute;');
	encodingString = encodingString.replace(//g, '&ucirc;');
	encodingString = encodingString.replace(//g, '&uuml;');
	encodingString = encodingString.replace(//g, '&yacute;');
	encodingString = encodingString.replace(//g, '&thorn;');
	encodingString = encodingString.replace(//g, '&yuml;');
	encodingString = encodingString.replace(/"/g, '&quot;');
	encodingString = encodingString.replace(/'/g, '&#39;');
	encodingString = encodingString.replace(/</g, '&lt;');
	encodingString = encodingString.replace(/>/g, '&gt;');

	return encodingString;
}

